From C4.Core Require Import
  Program
  Threads
  Object.

(* Confusing argument order. obj and impl should be swapped. *)
Definition Linearizable {Method} (obj: Spec Method) (impl: Object Method) :=
  ConcSimulates
    impl
    (serialObject obj).

Definition SelfLinearizable M (impl: Object M) :=
  Linearizable
    (coarsen impl)
    impl.
