Ltac solver'' := repeat (simpl in *; intuition; try autorewrite with core in *;
                         repeat match goal with
                                  | [ H : ex _ |- _ ] => destruct H
                                  | [ H : ?X = ?Y |- _ ] => subst X || subst Y
                                end).

Ltac solver' :=
  solver'';
  repeat (match goal with
            | [ H : _ = _ |- _ ] => rewrite H
          end; solver'').

Ltac solver :=
  solver';
    repeat (match goal with
              | [ |- context[match ?E with _ => _ end] ] => destruct E
            end; solver').
