Require Import
        Coq.Lists.List.

From C4.Core Require Import
  Program.
From C4.Extraction Require Import
  ExtractionMaps
  ExtractionIO
  Extraction.
Import ListNotations.

(* To run a test, uncomment it, interpret it and then run: *)
(* make -f MyMakefile run *)

(* Register { ------------------------------------------- *)
  
(* Require Import C4.Register. *)

(* Definition regp1: Program RegisterMethod nat := *)
(*   _ <- write 2; *)
(*   r <- read; *)
(*   b <- cas r 2; *)
(*   Return r. *)

(* Definition regp2: Program RegisterMethod nat := *)
(*   _ <- write 3; *)
(*   r <- read; *)
(*   b <- cas r 3; *)
(*   Return r. *)

(* Definition regpfun (v: nat): IO unit := *)
(*   print v. *)


(* Definition regmain := *)
(*   par *)
(*     atomicReg natRegObjTrans *)
(*     2 *)
(*     ([(regp1, regpfun); *)
(*         (regp2, regpfun)]). *)
(* Definition main := regmain. *)
(* Extraction "Main.hs" main.   *)

(* Register } ------------------------------------------- *)


(* Lock { ------------------------------------------- *)
(* Require Import C4.Lock. *)

(* Definition lp1: Program LockMethod unit := *)
(*   _ <- doLock; *)
(*   _ <- doUnlock; *)
(*   Return tt. *)

(* Definition lp2: Program LockMethod unit := *)
(*   _ <- doLock; *)
(*   r <- doUnlock; *)
(*   Return tt. *)

(* Definition lpfun (t: unit): IO unit := *)
(*   print 1. *)


(* Definition lmain := *)
(*   par *)
(*     atomicLock lockObjTrans *)
(*     false *)
(*     ([(lp1, lpfun); *)
(*         (lp2, lpfun)]). *)

(* Definition main := lmain. *)
(* Extraction "Main.hs" main.   *)

(* Lock } ------------------------------------------- *)


(* Pair { ------------------------------------------- *)

(* Require Import C4.Pair. *)
(* Require Import C4.Register. *)
(* Require Import C4.Lock. *)

(* Definition Inst := (PairMethod (@RegisterMethod nat) LockMethod). *)
(* Definition pairp1: Program Inst nat := *)
(*   _ <- inr doLock; *)
(*   r <- inl read; *)
(*   _ <- inr doUnlock; *)
(*   _ <- inr doLock; *)
(*   r <- inl read; *)
(*   _ <- inr doUnlock; *)
(*   Return r. *)

(* Definition pairp2: Program Inst nat := *)
(*   _ <- inr doLock; *)
(*   _ <- inl (write 7); *)
(*   _ <- inl (write 7); *)
(*   _ <- inl (write 7); *)
(*   r <- inl read; *)
(*   _ <- inr doUnlock; *)
(*   _ <- inr doLock; *)
(*   _ <- inl (write 2); *)
(*   _ <- inl (write 2); *)
(*   _ <- inl (write 2); *)
(*   _ <- inl (write 2); *)
(*   r <- inl read; *)
(*   _ <- inr doUnlock; *)
(*   Return r. *)

(* Definition pairpfun (n: nat): IO unit := *)
(*   print n. *)


(* Definition pairmain := *)
(*   par *)
(*     (pairSpec atomicReg atomicLock) *)
(*     (pairObjTrans natRegObjTrans lockObjTrans) *)
(*     (0, false) *)
(*     ([(pairp2, pairpfun); *)
(*       (pairp1, pairpfun)]). *)

(* Definition main := pairmain. *)
(* Extraction "Main.hs" main.   *)

(* Pair } ------------------------------------------- *)


(* Impl } ------------------------------------------- *)
(* Require Import C4.Object. *)
(* Require Import C4.Counter. *)
(* Require Import C4.Register. *)
(* Require Import C4.CounterImpl. *)


(* Module CounterImplArgs <: CounterImplParams. *)
(*   Definition reg := serialObject (@atomicReg nat). *)
(* End CounterImplArgs. *)
(* Module CounterImpl := CounterImplFun CounterImplArgs. *)
(* Import CounterImpl. *)

(* Definition p1: Program CounterMethod nat := *)
(*   _ <- fetch; *)
(*   r <- incAndFetch; *)
(*   Return r. *)

(* Definition p2: Program CounterMethod nat := *)
(*   _ <- fetch; *)
(*   r <- incAndFetch; *)
(*   Return r. *)


(* Definition rfun (n: nat): IO unit := *)
(*   print n. *)


(* Definition implmain := *)
(*   ipar *)
(*     counterImpl *)
(*     natRegObjTrans *)
(*     0 *)
(*     ([(p1, rfun); *)
(*       (p2, rfun)]). *)

(* Definition main := implmain. *)
(* Extraction "Main.hs" main. *)

(* Impl } ------------------------------------------- *)


(* BMap { ------------------------------------------- *)
(* Require Import Coq.Structures.Equalities. *)
(* Require Import Coq.Arith.Peano_dec. *)
(* Require Import C4.Maps. *)
(* Import BMap. *)

(* Module BMapArgs <: MiniDecidableType. *)
(*   Definition t := nat. *)
(*   Definition eq_dec := eq_nat_dec. *)
(* End BMapArgs. *)

(* Module CBMap := BMapFun BMapArgs. *)
(* Import CBMap. *)


(* Definition p1: Program (BMapMethod nat nat) nat := *)
(*   _ <- put 1 2; *)
(*   r <- get 1; *)
(*   Return *)
(*     match r with *)
(*     | Some i => i *)
(*     | None => 0 *)
(*     end. *)


(* Definition p2: Program (BMapMethod nat nat) nat := *)
(*   _ <- put 2 3; *)
(*   r <- get 2; *)
(*   Return *)
(*     match r with *)
(*     | Some i => i *)
(*     | None => 0 *)
(*     end. *)


(* Definition rfun (n: nat): IO unit := *)
(*   print n. *)


(* Definition main := *)
(*   par *)
(*     (atomicBMap nat) *)
(*     (bMapObjTrans nat) *)
(*     (initBMapState nat) *)
(*     ([(p1, rfun); *)
(*       (p2, rfun)]). *)

(* Extraction "Main.hs" main. *)


(* BMap } ------------------------------------------- *)




(* Array { ------------------------------------------- *)
(* Require Import C4.ArrayExt. *)
(* Require Import C4.Register. *)

(* Definition p1: Program (ArrayMethod RegisterMethod) nat := *)
(*   _ <- arrayCall 1 (cas 0 2); *)
(*   r <- arrayCall 1 read; *)
(*   s <- getSize; *)
(*   Return s. *)

(* Definition p2: Program (ArrayMethod RegisterMethod) nat := *)
(*   _ <- arrayCall 2 (cas 0 2); *)
(*   r <- arrayCall 2 read; *)
(*   s <- getSize; *)
(*   Return r. *)


(* Definition rfun (n: nat): IO unit := *)
(*   print n. *)

(* Definition st0: ArrayState (@atomicReg nat). *)
(*   refine (@initArrayState _ (@atomicReg nat) 0 (exist _ 7 _)). *)
(*   Proof. apply Lt.neq_0_lt. auto. Qed. *)


(* Definition main := *)
(*   par *)
(*     (absArray (@atomicReg nat)) *)
(*     (arrayTrans (@atomicReg nat) natRegObjTrans) *)
(*     st0 *)
(*     ([(p1, rfun); *)
(*       (p2, rfun)]). *)


(* Extraction "Main.hs" main. *)


(* Array } ------------------------------------------- *)


(* Impl ext } ------------------------------------------- *)
(* Require Import C4.Object. *)
(* Require Import C4.Register. *)
(* Require Import C4.Counter. *)
(* Require Import C4.CounterImpl. *)


(* Module CounterImplArgs <: CounterImplParams. *)
(*   Definition reg := serialObject (@atomicReg nat). *)
(* End CounterImplArgs. *)
(* Import CounterImplArgs. *)
(* Module CounterImpl := CounterImplFun CounterImplArgs. *)
(* Import CounterImpl. *)


(* Definition p1: Program CounterMethod nat := *)
(*   _ <- fetch; *)
(*   r <- incAndFetch; *)
(*   Return r. *)

(* Definition p2: Program CounterMethod nat := *)
(*   _ <- fetch; *)
(*   r <- incAndFetch; *)
(*   Return r. *)


(* Definition pairpfun (n: nat): IO unit := *)
(*   print n. *)


(* Definition main := *)
(*   iFlatPar *)
(*     impl *)
(*     natRegImplTrans *)
(*     0 *)
(*     ([(p1, pairpfun); *)
(*       (p2, pairpfun)]). *)

(* Extraction "Main.hs" main. *)

(* Impl ext } ------------------------------------------- *)

(* Impl array SHashMap } ------------------------------------------- *)
(* Require Import Coq.Structures.Equalities. *)
(* Require Import Coq.Arith.Peano_dec. *)
(* Require Import C4.Object. *)
(* Require Import C4.SHashMapExt. *)
(* Require Import C4.Maps. *)
(* Import EMap. *)

(* Module SHashMapArgs <: HashableType. *)
(*   Definition t := nat. *)
(*   Definition eq_dec := eq_nat_dec. *)
(*   Definition hash := @id nat. *)

(*   Module EMapArgs <: MiniDecidableType. *)
(*     Definition t := nat. *)
(*     Definition eq_dec := eq_nat_dec. *)
(*   End EMapArgs. *)

(*   Module CEMap := EMapFun EMapArgs. *)
(*   Import CEMap. *)
  
(*   Definition bucketMapImpl (Val: Type): Object (EMapMethod t Val) := *)
(*     serialObject (atomicEMap Val). *)

(*   Definition initBucketMapObjState (Val: Type): (bucketMapImpl Val).(objBase).(State) := *)
(*     initEMapState Val. *)
(* End SHashMapArgs. *)
(* Import SHashMapArgs. *)
(* Module SHashMap := SHashMapFun SHashMapArgs. *)
(* Import SHashMap. *)

(* Module CEMap := EMapFun SHashMapArgs. *)
(* Import CEMap. *)


(* Definition p1: Program (EMapMethod nat nat) nat := *)
(*   _ <- put 100 2; *)
(*   _ <- replaceIt 100 2 7; *)
(*   r <- get 100; *)
(*   Return *)
(*     match r with *)
(*     | Some i => i *)
(*     | None => 0 *)
(*     end. *)


(* Definition p2: Program (EMapMethod nat nat) nat := *)
(*   _ <- putIfAbsent 101 7; *)
(*   r <- remove 101; *)
(*   Return *)
(*     match r with *)
(*     | Some i => i *)
(*     | None => 0 *)
(*     end. *)

(* Definition rfun (n: nat): IO unit := *)
(*   print n. *)

(* Set Printing Implicit. *)
(* Set Printing All. *)


(* Definition st0: PArrayState (EMapState nat). *)
(*   refine (initPArrayState (initEMapState nat) (exist _ 7 _)). *)
(*   Proof. apply Lt.neq_0_lt. auto. Qed. *)


(* Definition main: ProgramIO unit := *)
(*   iFlatPar *)
(*     (@impl nat) *)
(*     (* (arrayImplTrans (bMapITrans nat)) *) *)
(*     (arrayImplTrans bMapITrans) *)
(*     st0 *)
(*     ([(p1, rfun); *)
(*       (p2, rfun)]). *)
    
(* Extraction "Main.hs" main. *)


(* Impl array, SHashMap } ------------------------------------------- *)


(* CHashMap { ------------------------------------------- *)
Require Import Coq.Structures.Equalities.
Require Import Coq.Arith.Peano_dec.
From C4 Require Import
  Object
  Lock
  SHashMapExt
  CHashMapExt
  Maps.
Import EMap.

Module SHashMapArgs <: HashableType.
  Definition t := nat.
  Definition eq_dec := eq_nat_dec.
  Definition hash := @id nat.

  Module EMapArgs <: MiniDecidableType.
    Definition t := nat.
    Definition eq_dec := eq_nat_dec.
  End EMapArgs.

  Module CEMap := EMapFun EMapArgs.
  Import CEMap.
  
  Definition bucketMapImpl (Val: Type): Object (EMapMethod t Val) :=
    serialObject (atomicEMap Val).
End SHashMapArgs.
Import SHashMapArgs.

Module SHashMap := SHashMapFun SHashMapArgs.
Import SHashMap.

Module CEMap := EMapFun SHashMapArgs.
Import CEMap.

Module Import CEMapExt := EMapFunExt SHashMapArgs CEMap.

Module CHashMapArgs <: CHashMapParams.

  Definition lockImpl: Object LockMethod :=
    serialObject atomicLock.
End CHashMapArgs.

Module CHashMap := CHashMapFun SHashMapArgs CHashMapArgs.
Import CHashMap.

Definition p1: Program (EMapMethod nat nat) nat :=
  _ <- put 100 2;
  _ <- replaceIt 100 2 7;
  r <- get 100;
  Return
    match r with
    | Some i => i
    | None => 0
    end.


Definition p2: Program (EMapMethod nat nat) nat :=
  _ <- putIfAbsent 101 7;
  r <- remove 101;
  Return
    match r with
    | Some i => i
    | None => 0
    end.

Definition rfun (n: nat): IO unit :=
  print n.


Definition st0: prod (PArrayState bool) (PArrayState (EMapState nat)).
  refine (
      (initPArrayState false (exist _ 5 _)),
      (initPArrayState (fun _ => None) (exist _ (5 * 4) _))).
  Proof.
    apply Lt.neq_0_lt. auto.
    simpl. apply Lt.neq_0_lt. auto.
  Qed.

  
Definition main: ProgramIO unit :=
  iFlatPar
    (@impl nat)
    (* (arrayImplTrans (bMapITrans nat)) *)
    (pairMTrans
       (arrayImplTrans lockMTrans)
       (arrayImplTrans bMapITrans))
    st0
    ([(p1, rfun);
      (p2, rfun)]).
    
Extraction "Main.hs" main.

(* CHashMap } ------------------------------------------- *)



(* Free tests } ------------------------------------------- *)

(* Definition def (o: option nat): nat := *)
(*   match o with *)
(*   | Some n => n + 1 *)
(*   | None => 1 *)
(*   end. *)

(* Extraction "Main.hs" def. *)


(* Definition main := *)
(*   l <-- newRegRep 2; *)
(*   r <-- cReadN l; *)
(*   _ <-- print 0; *)
(*   returnIO 0. *)

(* Definition main := *)
(*   l <-- newRegRep 2; *)
(*   cp l. *)


(* Definition main := *)
(*   l <-- newRegRep 2; *)
(*   (b <== cp l; *)
(*    _ <-- print b; *)
(*    returnIO 0). *)
(*   (* l <-- newRegRep 2; *) *)
(*   (* (b <== cp l; *) *)
(*   (*  _ <-- print b; *) *)
(*   (*  returnIO 0). *) *)

(* Extraction "Main.hs" main.   *)

(* Free tests } ------------------------------------------- *)
